require File.dirname(__FILE__) + '/spec_helper'

describe 'Up' do

  before :all do
    @up = UpYun.new('bucket', 'username', 'password', 0)
  end

  f = 'abcdefghijklmnopqrstuvwxyz\n'
  dir = '/upyun-sdk'

  context 'put file' do
    it 'does put file' do
      @up.put("#{dir}/ascii.txt", f).should be_true
    end
  end

  context 'get file' do
    it  'does get file' do
      @up.get("#{dir}/ascii.txt").size.should == f.size
    end
  end

  context 'getinfo' do
    it 'do get file info' do
      @up.getinfo("#{dir}/ascii.txt")[:file_size].to_i.should == f.size
    end
  end

  context 'getlist' do
    it 'do get directory list' do
      @up.getlist("#{dir}")[0][:size].to_i.should == f.size
    end
  end

  context 'usage' do
    it 'do get directory usage' do
      @up.usage("#{dir}").to_i.should == f.size
    end
  end

  context 'mkdir' do
    it 'do create directory' do
      @up.mkdir("#{dir}/temp/").should be_true
    end
  end

  context 'delete dir' do
    it 'do delete directory' do
      @up.delete("#{dir}/temp/").should be_true
    end
  end

  context 'delete file' do
    it 'do delete file' do
      @up.delete("#{dir}/ascii.txt").should be_true
    end
  end
end
